searchData={"items":[{"type":"module","title":"Serve.CLI","doc":"Starts HTTP Server in DIR (the current directory by default).\n\nUsage: `serve [OPTION] [DIR]`\n\nAvailable options:\n    -p, --port         specify the port to listen on (default: `4444`).\n    -o, --open         open the browser automatically.\n    -n, --no-index     disable directory listing.\n    -v, --version      output version information and exit\n    -h, --help         display this help and exit\n\nExamples:\n    serve\n    serve path/to/web\n    serve -op 3000","ref":"Serve.CLI.html"},{"type":"function","title":"Serve.CLI.main/1","doc":"","ref":"Serve.CLI.html#main/1"},{"type":"extras","title":"Serve","doc":"# Serve\n\n[![Actions Status](https://github.com/quexpl/serve/workflows/CI/badge.svg)](https://github.com/quexpl/serve/actions?query=workflow%3ACI)\n[![Hex pm](https://img.shields.io/hexpm/v/serve.svg?style=flat)](https://hex.pm/packages/serve)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/serve)\n\n\n**Serve** is escript to quickly start an HTTP server, similar to quick-start solutions available in other languages:\n\n```shell\n$ php -S localhost:8080\n$ ruby -run -e httpd . -p 8080\n$ python3 -m http.server 8080\n```\n\nWith **Serve**, you can quickly start an HTTP server:\n\n```shell\n$ serve /var/www/html\n[info] Serving /var/www/html with Cowboy 2.13.0 at http://127.0.0.1:4444\n```","ref":"readme.html"},{"type":"extras","title":"Installation - Serve","doc":"To install from Hex, run:\n\n    $ mix escript.install hex serve\n\nTo build and install it locally run:\n\n    $ mix install\n\nit's a alias for:\n\n    $ mix do deps.get, escript.build, escript.install\n\n> Note: For convenience, consider adding `~/.mix/escripts` directory to your `$PATH` environment variable.\n> If you are using [asdf](https://github.com/asdf-vm/asdf) Whenever you install a new escript with `mix escript.install` you need to `asdf reshim elixir` in order to create shims for it.\n\nIf you want to uninstall Serve simply run:\n\n    $ mix escript.uninstall serve","ref":"readme.html#installation"},{"type":"extras","title":"Options - Serve","doc":"","ref":"readme.html#options"},{"type":"extras","title":"Comand line options - Serve","doc":"You can pass options directly to `serve`\n\n- `-p`, `--port` - Specify the port to listen on (default: `4444`).\n- `-o`, `--open` - Open the browser automatically.\n- `-n`, `--no-index` - Disable directory listing.\n- `-v`, `--version` - Shows Serve version.\n- `-h`, `--help` - Shows Serve usage information.\n\n```shell\n$ serve --port 3000\n```","ref":"readme.html#comand-line-options"},{"type":"extras","title":"Environment variables - Serve","doc":"Serve also supports environment variables for all options. Simply use env with `MIX_SERVE_` prefix.\n\n```shell\n$ MIX_SERVE_PORT=3000 serve\n```\n\nYou can also add exports to yours profile file, for example:\n```\nexport MIX_SERVE_PORT=8000\nexport MIX_SERVE_OPEN=true\nexport MIX_SERVE_NO_INDEX=true\n```","ref":"readme.html#environment-variables"},{"type":"extras","title":"Arguments - Serve","doc":"Serve accepts one argument: the directory to be served. If no directory is specified, the current working directory is used.\n\n```shell\n$ pwd\n/var/www/html/my_website\n$ serve\n[info] Serving  /var/www/html/my_website with Cowboy 2.13.0 at http://localhost:4444\n```\n\n```shell\n$ mix docs\nGenerating docs...\nView \"html\" docs at \"doc/index.html\"\nView \"epub\" docs at \"doc/serve.epub\"\n$ serve s doc\n[info] Serving  /home/quex/workspace/serve/doc with Cowboy 2.13.0 at http://localhost:4444\n```","ref":"readme.html#arguments"},{"type":"extras","title":"Features - Serve","doc":"- dark mode\n- directory index\n\n![dark mode](https://github.com/quexpl/serve/blob/main/images/index-dark.jpg?raw=true)\n![directory index](https://github.com/quexpl/serve/blob/main/images/index.jpg?raw=true)\n![not found](https://github.com/quexpl/serve/blob/main/images/404.jpg?raw=true)","ref":"readme.html#features"},{"type":"extras","title":"Security - Serve","doc":"Although Serve uses the robust Cowboy HTTP server, it is not intended to be a production-ready web server. It only supports the HTTP protocol and listens on the loopback interface.","ref":"readme.html#security"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"changelog.html"},{"type":"extras","title":"v0.1.0 (2025-02-20) - Changelog","doc":"* First release","ref":"changelog.html#v0-1-0-2025-02-20"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}